package de.privacynerd.chatbeautifier;

import de.privacynerd.chatbeautifier.displaynamecolor.ChatColorCommand;
import de.privacynerd.chatbeautifier.displaynamecolor.ChooseChatColorListener;
import org.bukkit.Bukkit;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;


public final class ChatBeautifier extends JavaPlugin {
    public static String PREFIX = "§a[ChatBeautifier] §7§o";
    public static ChatBeautifier INSTANCE;

    public ChatBeautifier() {
        INSTANCE = this;
    }
    public void log(String text) {
        Bukkit.getConsoleSender().sendMessage(PREFIX + text);
    }


    @Override
    public void onEnable() {  // the plugin startup logic
        // register listeners
        PluginManager pluginManager = Bukkit.getPluginManager();
        pluginManager.registerEvents(new JoinQuitListener(), this);
        log("JoinQuitListener has been registered.");
        pluginManager.registerEvents(new ChatListener(), this);
        log("ChatListener has been registered.");
        pluginManager.registerEvents(new ChooseChatColorListener(), this);
        log("ChooseChatColorListener has been registered.");

        Bukkit.getPluginCommand("set-chat-color").setExecutor(new ChatColorCommand());
        log("ChatColorCommand has been set as executor for the command 'set-chat-color'.");

        log("Plugin enabled.");
    }

    @Override
    public void onDisable() {
        log("Plugin disabled.");
    }
}