package de.privacynerd.chatbeautifier;

import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;


public class JoinQuitListener implements Listener {

    @EventHandler
    public void onPlayerJoin(PlayerJoinEvent event) {
        Player player = event.getPlayer();
        Component newName;

        if(player.isOp()) {
            newName = Component.text("[OP] "+player.getName(), NamedTextColor.RED);
            player.displayName(newName);
            player.playerListName(newName);
        } else {
            newName = Component.text(player.getName(), NamedTextColor.GRAY);
            player.displayName(Component.text(player.getName()));
            player.playerListName(newName);
        }

        event.joinMessage(Component.text(">> ", NamedTextColor.GREEN).append(player.displayName()));
        player.playSound(player.getLocation(), Sound.AMBIENT_CRIMSON_FOREST_MOOD, 0.5f, 0.4f);
    }


    @EventHandler
    public void onPlayerQuit(PlayerQuitEvent event) {
        Player player = event.getPlayer();

        event.quitMessage(Component.text("<< ", NamedTextColor.RED).append(player.displayName()));
    }
}
