package de.privacynerd.chatbeautifier.displaynamecolor;

import de.privacynerd.chatbeautifier.ChatBeautifier;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;

public class ChatColorCommand implements CommandExecutor {
    @Override
    public boolean onCommand(@NotNull CommandSender commandSender, @NotNull Command command, @NotNull String alias, @NotNull String[] args) {
        ChatBeautifier.INSTANCE.log("Command /set-chat-name executed.");

        if(!(commandSender instanceof Player)) {
            ChatBeautifier.INSTANCE.log("This command was not executed by a player. Not doing anything.");
            return false;
        }
        Player player = (Player) commandSender;
        String validArgument = "";
        Component newDisplayName;

        // check for the right args
        if(args.length == 1) {
            switch (args[0]) {
                case "black":
                    validArgument = "black";
                    newDisplayName = Component.text("", ChatColorUtils.getChooseColorCodes().get(1)).append(player.displayName());
                    player.displayName(newDisplayName);
                    player.playerListName(newDisplayName);
                    break;
                case "gray":
                    validArgument = "gray";
                    newDisplayName = player.displayName().color(ChatColorUtils.getChooseColorCodes().get(1));
                    player.displayName(newDisplayName);
                    player.playerListName(newDisplayName);
                    break;
                case "light-gray":
                    validArgument = "light-gray";
                    newDisplayName = player.displayName().color(ChatColorUtils.getChooseColorCodes().get(2));
                    player.displayName(newDisplayName);
                    player.playerListName(newDisplayName);
                    break;
                case "white":
                    validArgument = "white";
                    newDisplayName = player.displayName().color(ChatColorUtils.getChooseColorCodes().get(3));
                    player.displayName(newDisplayName);
                    player.playerListName(newDisplayName);
                    break;
                case "brown":
                    validArgument = "brown";
                    newDisplayName = player.displayName().color(ChatColorUtils.getChooseColorCodes().get(4));
                    player.displayName(newDisplayName);
                    player.playerListName(newDisplayName);
                    break;
                case "red":
                    validArgument = "red";
                    newDisplayName = player.displayName().color(ChatColorUtils.getChooseColorCodes().get(5));
                    player.displayName(newDisplayName);
                    player.playerListName(newDisplayName);
                    break;
                case "orange":
                    validArgument = "orange";
                    newDisplayName = player.displayName().color(ChatColorUtils.getChooseColorCodes().get(6));
                    player.displayName(newDisplayName);
                    player.playerListName(newDisplayName);
                    break;
                case "yellow":
                    validArgument = "yellow";
                    newDisplayName = player.displayName().color(ChatColorUtils.getChooseColorCodes().get(7));
                    player.displayName(newDisplayName);
                    player.playerListName(newDisplayName);
                    break;
                case "light-green":
                    validArgument = "light-green";
                    newDisplayName = player.displayName().color(ChatColorUtils.getChooseColorCodes().get(8));
                    player.displayName(newDisplayName);
                    player.playerListName(newDisplayName);
                    break;
                case "dark-green":
                    validArgument = "dark-green";
                    newDisplayName = player.displayName().color(ChatColorUtils.getChooseColorCodes().get(9));
                    player.displayName(newDisplayName);
                    player.playerListName(newDisplayName);
                    break;
                case "cyan":
                    validArgument = "cyan";
                    newDisplayName = player.displayName().color(ChatColorUtils.getChooseColorCodes().get(10));
                    player.displayName(newDisplayName);
                    player.playerListName(newDisplayName);
                    break;
                case "blue":
                    validArgument = "blue";
                    newDisplayName = player.displayName().color(ChatColorUtils.getChooseColorCodes().get(11));
                    player.displayName(newDisplayName);
                    player.playerListName(newDisplayName);
                    break;
                case "purple":
                    validArgument = "purple";
                    newDisplayName = player.displayName().color(ChatColorUtils.getChooseColorCodes().get(12));
                    player.displayName(newDisplayName);
                    player.playerListName(newDisplayName);
                    break;
                case "magenta":
                    validArgument = "magenta";
                    newDisplayName = player.displayName().color(ChatColorUtils.getChooseColorCodes().get(13));
                    player.displayName(newDisplayName);
                    player.playerListName(newDisplayName);
                    break;
                case "pink":
                    validArgument = "pink";
                    newDisplayName = player.displayName().color(ChatColorUtils.getChooseColorCodes().get(14));
                    player.displayName(newDisplayName);
                    player.playerListName(newDisplayName);
                    break;
                case "list":
                    ChatBeautifier.INSTANCE.log("Got valid argument 'list', printing list of valid colors...");
                    ArrayList<String> colorNames = ChatColorUtils.getChooseColorStrings();

                    // now compose the message containing all possible color args
                    StringBuilder message = new StringBuilder(ChatBeautifier.PREFIX + "§r§lMögliche Farben: §r§o");
                    message.append(colorNames.get(0).toLowerCase().replace(" ", "-")).append(", ");
                    for (int i=1; i<colorNames.toArray().length; i++) {
                        message.append(colorNames.get(i).toLowerCase().replace(" ", "-")).append(", ");
                    }

                    // and send it
                    player.sendMessage(message.toString());
                    return true;
                case "gui":
                    ChatBeautifier.INSTANCE.log("Got valid argument 'gui', opening gui...");
                    player.openInventory(new ChooseChatColorGUI().getGUI(player));
                    return true;
                default:
                    // print a help string if no valid argument is given
                    player.sendMessage(ChatBeautifier.PREFIX + "Verwendung: /" + alias + " [<color>, list, gui]");
                    return true;
            }
            ChatBeautifier.INSTANCE.log("Got valid color " + validArgument);
            player.sendMessage(ChatBeautifier.PREFIX + "Name temporär " + validArgument + " gefärbt. Dieses Feature ist aktuell noch in der Mache, dauerhaft coming soon.");
            return true;
        } else if (args.length > 1) {  // print a help string if more than one argument is given
            player.sendMessage(ChatBeautifier.PREFIX + "Verwendung: /" + alias + " [<color>, list, gui]");
            return true;
        } else {
            player.openInventory(new ChooseChatColorGUI().getGUI(player));
            return true;
        }
    }
}
